using System;
using System.IO;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.IO;
using GHIElectronics.NETMF.IO;
using System.Text;


class SD
{

    private PersistentStorage card;
    private FileStream FileHandle;
    private bool isInitialized = false; 


    public SD()
    {
        init();
    }



    public bool getIsInitialized() 
    {
        return isInitialized;
    }

    public void init()
    {

        card = new PersistentStorage("SD");

    }




    public bool hasSDcard()
    {
        return PersistentStorage.DetectSDCard();
    }


    /// <summary>
    /// mountCard will mount the SD card on the device. It returns a boolean wherether the 
    /// action succeeded and the volume has a valid formatting.
    /// </summary>
    /// <returns></returns>
    public bool mountCard()
    {
        card.MountFileSystem();
        return (VolumeInfo.GetVolumes()[0].IsFormatted);
    }




    /// <summary>
    /// UnMountCard will unmount the SD card from the device.
    /// </summary>
    public void unMountCard()
    {
        card.UnmountFileSystem();
    }



    public void openFile(String name)
    {
        string rootDirectory = VolumeInfo.GetVolumes()[0].RootDirectory;
        FileHandle = new FileStream(rootDirectory + @"\" + name, FileMode.Create);
    }



    public void writeFile(String text)
    {
        byte[] data =Encoding.UTF8.GetBytes(text);
        // write the data and close the file
        FileHandle.Write(data, 0, data.Length);
    }



    public void closeFile()
    {
        FileHandle.Close();
    }
}

